package com.zhongzheng.modules.user.service;

import com.zhongzheng.modules.course.vo.CourseVo;
import com.zhongzheng.modules.goods.vo.GoodsVo;
import com.zhongzheng.modules.user.domain.UserPlan;
import com.zhongzheng.modules.user.vo.UserPlanVo;
import com.zhongzheng.modules.user.bo.UserPlanQueryBo;
import com.zhongzheng.modules.user.bo.UserPlanAddBo;
import com.zhongzheng.modules.user.bo.UserPlanEditBo;
import com.baomidou.mybatisplus.extension.service.IService;

import java.text.ParseException;
import java.util.Collection;
import java.util.List;

/**
 * 学习计划Service接口
 *
 * @author ruoyi
 * @date 2021-12-08
 */
public interface IUserPlanService extends IService<UserPlan> {
	/**
	 * 查询单个
	 * @return
	 */
	UserPlanVo queryById(UserPlanQueryBo bo);

	/**
	 * 查询列表
	 */
	List<UserPlanVo> queryList(UserPlanQueryBo bo);

	/**
	 * 根据新增业务对象插入学习计划
	 * @param bo 学习计划新增业务对象
	 * @return
	 */
	Boolean insertByAddBo(UserPlanAddBo bo) throws ParseException;

	/**
	 * 根据编辑业务对象修改学习计划
	 * @param bo 学习计划编辑业务对象
	 * @return
	 */
	Boolean updateByEditBo(UserPlanEditBo bo) throws ParseException;

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    UserPlanVo listPlan(UserPlanEditBo bo) throws ParseException;

	List<GoodsVo> listGoods(UserPlanQueryBo bo);

	List<UserPlanVo> userPlanSeven(UserPlanQueryBo bo) throws ParseException;
}
